<?php

include_once get_template_directory() . '/functions/inkthemes-functions.php';
$functions_path = get_template_directory() . '/functions/';
require_once ($functions_path . 'admin-interface.php');  // Admin Interfaces (options,framework, seo)
require_once ($functions_path . 'theme-options.php');   // Options panel settings and custom settings
/*
 * Style Enqueue
 */

function rethink_add_style() {
    if (!is_admin()) {
        wp_enqueue_style('google-font', "//fonts.googleapis.com/css?family=Lato:100,300,400,700,900,100italic,300italic,400italic,700italic,900italic", '', '', 'all');
        wp_enqueue_style('reset-stylesheet', get_template_directory_uri() . '/css/reset.css', '', '', 'all');
        wp_enqueue_style('resopnsive-stylesheet', get_template_directory_uri() . '/css/960_24_col_responsive.css', '', '', 'all');
        wp_enqueue_style('stylesheet', get_stylesheet_uri(), '', '', 'all');
    }
}

add_action('wp_enqueue_scripts', 'rethink_add_style');

/*
 * jQuery Enqueue
 */

function rethink_wp_enqueue_scripts() {
    if (!is_admin()) {
        wp_enqueue_script('rethink-superfish', get_template_directory_uri() . '/js/superfish.js', array('jquery'));
        wp_enqueue_script('rethink-custom', get_template_directory_uri() . '/js/custom.js', array('jquery'));
        wp_enqueue_script('mobile-menu', get_template_directory_uri() . "/js/mobile-menu.js", array('jquery'), '', true);
    }
}

add_action('wp_enqueue_scripts', 'rethink_wp_enqueue_scripts');

/*
 * Enqueues the javascript for comment replys  
 */

function rethink_enqueue_scripts() {
    if (is_singular() and get_site_option('thread_comments')) {
        wp_print_scripts('comment-reply');
    }
}

add_action('wp_enqueue_scripts', 'rethink_enqueue_scripts');
require_once(get_template_directory() . '/functions/plugin-activation.php');
require_once(get_template_directory() . '/functions/plugin-notify.php');
add_action('tgmpa_register', 'rethink_plugins_notify');

function rethink_save_option($option) {
    return update_option('rethink_options', $option);
}

function rethink_get_option($name) {
    $options = get_option('rethink_options');
    if (isset($options[$name]))
        return $options[$name];
}

function rethink_delete_option($name) {
    $options = get_option('rethink_options');
    unset($options[$name]);
    return update_option('rethink_options', $options);
}

?>