<?php

// OptionsFramework Admin Interface
/* ----------------------------------------------------------------------------------- */
/* Options Framework Admin Interface - optionsframework_add_admin */
/* ----------------------------------------------------------------------------------- */
// Load static framework options pages 
function rethink_optionsframework_add_admin() {
    global $query_string;

    if (isset($_REQUEST['page']) && $_REQUEST['page'] == 'optionsframework') {
        if (isset($_REQUEST['of_save']) && 'reset' == $_REQUEST['of_save']) {
            rethink_reset_options();
            header("Location: admin.php?page=optionsframework&reset=true");
            die;
        }
    }
    $theme_option = rethink_get_option_defaults();
    $themename = $theme_option['theme_name'];
    $of_page = add_theme_page($themename, __('Theme Options', 'rethink'), 'edit_theme_options', 'optionsframework', 'rethink_optionsframework_options_page', 'div');

    // Add framework functionaily to the head individually
    add_action("admin_print_scripts-$of_page", 'rethink_load_only');
}

add_action('admin_menu', 'rethink_optionsframework_add_admin');
/* ----------------------------------------------------------------------------------- */
/* Options Framework Reset Function - of_reset_options */
/* ----------------------------------------------------------------------------------- */

function rethink_reset_options() {
    delete_option('rethink_options');
}

/* ----------------------------------------------------------------------------------- */
/* Build the Options Page - optionsframework_options_page */
/* ----------------------------------------------------------------------------------- */

function rethink_optionsframework_options_page() {
    $options = rethink_get_option_defaults();
    $themename = $options['theme_name'];
    ?>
    <div class="trail-notify">
        <h1><?php _e('Get Rethink PRO!', 'rethink') ?></h1>
        <p style="font-size:15px; line-height: 20px;"><?php _e('You are using the free version of Rethink theme. Upgrade to pro for extra features like home page slider, featured section, testimonial, boxed blog layout, fullWidth, contact page templates and many other, premium theme support and much more.', 'rethink') ?></p>
        <a href="<?php echo esc_url('http://www.inkthemes.com/wp-themes/rethink-product-review-wordpress-theme/'); ?>" target="blank"><?php _e('Upgrade to Rethink PRO here &raquo;', 'rethink') ?></a>
    </div>
    <div class="wrap1" id="of_container">
        <div id="of-popup-save" class="of-save-popup">
            <div class="of-save-save"><?php _e('Options Updated', 'rethink'); ?></div>
        </div>
        <div id="of-popup-reset" class="of-save-popup">
            <div class="of-save-reset"><?php _e('Options Reset', 'rethink'); ?></div>
        </div>
        <form action="" enctype="multipart/form-data" id="ofform">
            <div id="header">
                <div class="logo">
                    <h2><?php echo $themename; ?><?php _e('Options', 'rethink'); ?></h2>
                </div>
                <a href="<?php esc_url('http://www.inkthemes.com'); ?>" target="_blank">
                    <div class="icon-option"> </div>
                </a>
                <div class="clear"></div>
            </div>
            <?php
            // Rev up the Options Machine
            $return = rethink_optionsframework_machine($options);
            ?>
            <div id="main">
                <div id="of-nav">
                    <ul>
                        <?php echo $return[1] ?>
                    </ul>
                </div>
                <div id="content"> <?php echo $return[0]; /* Settings */ ?> </div>
                <div class="clear"></div>
            </div>
            <div class="save_bar_right save_bar_top">
                <img style="display:none" src="<?php echo get_template_directory_uri(); ?>/functions/images/loading-bottom.gif" class="ajax-loading-img ajax-loading-img-bottom" alt="<?php _e('Working...', 'rethink'); ?>" />
                <input type="submit" value="<?php _e('Save All Changes', 'rethink'); ?>" class="button-primary" id="save-options"/>
            </div>
        </form>
        <div class="save_bar_left save_bar_top">
            <form action="<?php echo esc_url($_SERVER['REQUEST_URI']) ?>" method="post" style="display:inline" id="ofform-reset">
                <span class="submit-footer-reset">
                    <input name="reset" type="submit" value="<?php _e('Reset Options', 'rethink') ?>" class="button submit-button reset-button" onclick="return confirm('<?php _e('Click OK to reset. All settings will be lost!', 'rethink'); ?>');" />
                    <input type="hidden" name="of_save" value="reset" />
                </span>
            </form>
        </div>
        <?php if (!empty($update_message)) echo $update_message; ?>
        <div style="clear:both;"></div>
    </div>
    <!--wrap-->
    <?php
}

/* ----------------------------------------------------------------------------------- */
/* Load required javascripts for Options Page - of_load_only */
/* ----------------------------------------------------------------------------------- */

function rethink_load_only() {
    add_action('admin_head', 'of_admin_head');

    wp_enqueue_script('jquery-ui-core');
    wp_register_script('jquery-input-mask', get_template_directory_uri() . '/functions/js/jquery.maskedinput-1.2.2.js', array('jquery'));
    wp_enqueue_script('jquery-input-mask');

    function of_admin_head() {

        echo '<link rel="stylesheet" type="text/css" href="' . get_template_directory_uri() . '/functions/admin-style.css" media="screen" />';
        // COLOR Picker 
        ?>
        <link rel="stylesheet" media="screen" type="text/css" href="<?php echo get_template_directory_uri(); ?>/functions/css/colorpicker.css" />        
        <?php
        wp_enqueue_script('rethink-colorpikerjs', get_template_directory_uri() . '/functions/js/colorpicker.js', array('jquery'));
        wp_enqueue_script('rethink-uploadjs', get_template_directory_uri() . '/functions/js/ajaxupload.js', array('jquery'));
        wp_enqueue_script('rethink-adminjs', get_template_directory_uri() . '/functions/js/adminjs.js', array('jquery'));
        $is_reset = isset($_REQUEST['reset']) ? $_REQUEST['reset'] : 'false';
        $ajax_type = (isset($_REQUEST['page']) && $_REQUEST['page'] == 'optionsframework') ? 'options' : '';
        wp_localize_script('rethink-adminjs', 'adminobj', array('ajaxurl' => admin_url("admin-ajax.php"),
            'is_reset' => $is_reset,
            'ajax_type' => $ajax_type)
        );
    }

}

/* ----------------------------------------------------------------------------------- */
/* Ajax Save Action - rethink_ajax_callback */
/* ----------------------------------------------------------------------------------- */
add_action('wp_ajax_of_ajax_post_action', 'rethink_ajax_callback');

function rethink_ajax_callback() {
    global $wpdb, $options_to_save; // this is how you get access to the database
    $options_to_save = array();
    $save_type = $_POST['type'];
    //Uploads
    if ($save_type == 'upload') {

        $clickedID = $_POST['data']; // Acts as the name
        $filename = $_FILES[$clickedID];
        $filename['name'] = preg_replace('/[^a-zA-Z0-9._\-]/', '', $filename['name']);
        $override['test_form'] = false;
        $override['action'] = 'wp_handle_upload';
        $uploaded_file = wp_handle_upload($filename, $override);
        $response = array();
        if (isset($uploaded_file) && ($uploaded_file['type'] == 'image/gif' || $uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg' || $uploaded_file['type'] == 'image/png' || $uploaded_file['type'] == 'image/svg+xml' )) {
            $upload_tracking[] = $clickedID;
            $options_to_save[$clickedID] = $uploaded_file['url'];
            if (!empty($uploaded_file['error'])) {
                $response['error'] = __('Upload Error: ', 'rethink') . $uploaded_file['error'];
            } else {
                $response['url'] = $uploaded_file['url'];
            }
        } else {
            $response['error'] = __('Unsupported filetype uploaded.', 'rethink');
        } // Is the Response
        echo json_encode($response);
        die();
    } elseif ($save_type == 'image_reset') {

        $id = $_POST['data']; // Acts as the name
        delete_option($id);
    } elseif ($save_type == 'options' OR $save_type == 'framework') {
        $data = $_POST['data'];
        parse_str($data, $output);
        $of_template = rethink_get_option_defaults();
        $options = $of_template['of_template'];
        foreach ($options as $option_array) {
            $id = $option_array['id'];
            $old_value = rethink_get_option($id);
            $new_value = '';

            if (isset($output[$id])) {
                $new_value = $output[$option_array['id']];
            }

            if (isset($option_array['id'])) { // Non - Headings...
                $type = $option_array['type'];

                if (is_array($type)) {

                    foreach ($type as $array) {
                        if ($array['type'] == 'text') {
                            $id = $array['id'];
                            $std = $array['std'];
                            $new_value = $output[$id];
                            if ($new_value == '') {
                                $new_value = $std;
                            }
                            $new_value = sanitize_text_field($new_value);
                            $options_to_save[$id] = stripslashes($new_value);
                        }
                    }
                } elseif ($new_value == '' && $type == 'checkbox') { // Checkbox Save
                    $options_to_save[$id] = 'false';
                } elseif ($new_value == 'true' && $type == 'checkbox') { // Checkbox Save
                    $options_to_save[$id] = 'true';
                } elseif ($type == 'multicheck') { // Multi Check Save
                    $option_options = $option_array['options'];

                    foreach ($option_options as $options_id => $options_value) {

                        $multicheck_id = $id . "_" . $options_id;

                        if (!isset($output[$multicheck_id])) {
                            $options_to_save[$multicheck_id] = 'false';
                        } else {
                            $options_to_save[$multicheck_id] = 'true';
                        }
                    }
                } elseif ($type == 'typography') {

                    $typography_array = array();

                    $typography_array['size'] = $output[$option_array['id'] . '_size'];

                    $typography_array['face'] = stripslashes($output[$option_array['id'] . '_face']);

                    $typography_array['style'] = $output[$option_array['id'] . '_style'];

                    $typography_array['color'] = $output[$option_array['id'] . '_color'];
                    $options_to_save[$id] = $typography_array;
                } elseif ($type == 'border') {

                    $border_array = array();

                    $border_array['width'] = $output[$option_array['id'] . '_width'];

                    $border_array['style'] = $output[$option_array['id'] . '_style'];

                    $border_array['color'] = $output[$option_array['id'] . '_color'];
                    $options_to_save[$id] = $border_array;
                } elseif ($type == 'textarea') {
                    $new_value = esc_textarea($new_value);
                    $options_to_save[$id] = stripslashes($new_value);
                } elseif ($type != 'upload_min') {
                    $options_to_save[$id] = stripslashes($new_value);
                }
            }
        }
    }
    rethink_save_option($options_to_save);
    die();
}

/* ----------------------------------------------------------------------------------- */
/* Generates The Options Within the Panel - optionsframework_machine */
/* ----------------------------------------------------------------------------------- */

function rethink_optionsframework_machine($options) {

    $counter = 0;
    $menu = '';
    $output = '';
    foreach ($options['of_template'] as $value) {

        $counter++;
        $val = '';
        //Start Heading
        if ($value['type'] != "heading") {
            $class = '';
            if (isset($value['class'])) {
                $class = $value['class'];
            }
            //$output .= '<div class="section section-'. $value['type'] .'">'."\n".'<div class="option-inner">'."\n";
            $output .= '<div class="section section-' . $value['type'] . ' ' . $class . '">' . "\n";
            $output .= '<h3 class="heading">' . $value['name'] . '</h3>' . "\n";
            $output .= '<div class="option">' . "\n" . '<div class="controls">' . "\n";
        }
        //End Heading

        $select_value = '';
        switch ($value['type']) {

            case 'text':
                $val = $value['std'];
                $std = rethink_get_option($value['id']);
                if ($std != "") {
                    $val = $std;
                }
                $output .= '<input class="of-input" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '" type="' . $value['type'] . '" value="' . esc_attr($val) . '" />';
                break;

            case 'select':
                $output .= '<select class="of-input" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '">';

                $select_value = rethink_get_option($value['id']);

                foreach ($value['options'] as $option) {

                    $selected = '';

                    if ($select_value != '') {
                        if ($select_value == $option) {
                            $selected = ' selected="selected"';
                        }
                    } else {
                        if (isset($value['std']))
                            if ($value['std'] == $option) {
                                $selected = ' selected="selected"';
                            }
                    }

                    $output .= '<option' . $selected . '>';
                    $output .= $option;
                    $output .= '</option>';
                }
                $output .= '</select>';

                break;
            case 'select2':
                $output .= '<select class="of-input" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '">';

                $select_value = rethink_get_option($value['id']);

                foreach ($value['options'] as $option => $name) {

                    $selected = '';

                    if ($select_value != '') {
                        if ($select_value == $option) {
                            $selected = ' selected="selected"';
                        }
                    } else {
                        if (isset($value['std']))
                            if ($value['std'] == $option) {
                                $selected = ' selected="selected"';
                            }
                    }

                    $output .= '<option' . $selected . ' value="' . $option . '">';
                    $output .= $name;
                    $output .= '</option>';
                }
                $output .= '</select>';

                break;
            case 'textarea':

                $cols = '8';
                $ta_value = '';

                if (isset($value['std'])) {

                    $ta_value = $value['std'];

                    if (isset($value['options'])) {
                        $ta_options = $value['options'];
                        if (isset($ta_options['cols'])) {
                            $cols = $ta_options['cols'];
                        } else {
                            $cols = '8';
                        }
                    }
                }
                $std = rethink_get_option($value['id']);
                if ($std != "") {
                    $ta_value = stripslashes($std);
                }
                $output .= '<textarea class="of-input" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '" cols="' . esc_attr($cols) . '" rows="8">' . esc_textarea($ta_value) . '</textarea>';


                break;
            case "radio":

                $select_value = rethink_get_option($value['id']);

                foreach ($value['options'] as $key => $option) {
                    $checked = '';
                    if ($select_value != '') {
                        if ($select_value == $key) {
                            $checked = ' checked';
                        }
                    } else {
                        if ($value['std'] == $key) {
                            $checked = ' checked';
                        }
                    }
                    $output .= '<input class="of-input of-radio" type="radio" name="' . esc_attr($value['id']) . '" value="' . esc_attr($key) . '" ' . $checked . ' />' . $option . '<br />';
                }

                break;
            case "checkbox":

                $std = $value['std'];

                $saved_std = rethink_get_option($value['id']);

                $checked = '';

                if (!empty($saved_std)) {
                    if ($saved_std == 'true') {
                        $checked = 'checked="checked"';
                    } else {
                        $checked = '';
                    }
                } elseif ($std == 'true') {
                    $checked = 'checked="checked"';
                } else {
                    $checked = '';
                }
                $output .= '<input type="checkbox" class="checkbox of-input" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '" value="true" ' . $checked . ' />';
                break;
            case "multicheck":

                $std = $value['std'];

                foreach ($value['options'] as $key => $option) {

                    $of_key = $value['id'] . '_' . $key;
                    $saved_std = rethink_get_option($of_key);

                    if (!empty($saved_std)) {
                        if ($saved_std == 'true') {
                            $checked = 'checked="checked"';
                        } else {
                            $checked = '';
                        }
                    } elseif ($std == $key) {
                        $checked = 'checked="checked"';
                    } else {
                        $checked = '';
                    }
                    $output .= '<input type="checkbox" class="checkbox of-input" name="' . esc_attr($of_key) . '" id="' . esc_attr($of_key) . '" value="true" ' . $checked . ' /><label for="' . esc_attr($of_key) . '">' . esc_attr($option) . '</label><br />';
                }
                break;
            case "upload":
                $value['std'] = '';
                if (isset($value['std'])) {
                    $output .= rethink_optionsframework_uploader_function(esc_attr($value['id']), esc_attr($value['std']), null);
                }
                break;
            case "upload_min":

                $output .= rethink_optionsframework_uploader_function(esc_attr($value['id']), esc_attr($value['std']), 'min');

                break;
            case "color":
                $val = $value['std'];
                $stored = rethink_get_option($value['id']);
                if ($stored != "") {
                    $val = $stored;
                }
                $output .= '<div id="' . esc_attr($value['id']) . '_picker" class="colorSelector"><div></div></div>';
                $output .= '<input class="of-color" name="' . esc_attr($value['id']) . '" id="' . esc_attr($value['id']) . '" type="text" value="' . esc_attr($val) . '" />';
                break;

            case "typography":

                $default = $value['std'];
                $typography_stored = rethink_get_option($value['id']);

                /* Font Size */
                $val = $default['size'];
                if ($typography_stored['size'] != "") {
                    $val = $typography_stored['size'];
                }
                $output .= '<select class="of-typography of-typography-size" name="' . esc_attr($value['id']) . '_size" id="' . esc_attr($value['id']) . '_size">';
                for ($i = 9; $i < 71; $i++) {
                    if ($val == $i) {
                        $active = 'selected="selected"';
                    } else {
                        $active = '';
                    }
                    $output .= '<option value="' . $i . '" ' . $active . '>' . $i . 'px</option>';
                }
                $output .= '</select>';

                /* Font Face */
                $val = $default['face'];
                if ($typography_stored['face'] != "")
                    $val = $typography_stored['face'];
                $font01 = '';
                $font02 = '';
                $font03 = '';
                $font04 = '';
                $font05 = '';
                $font06 = '';
                $font07 = '';
                $font08 = '';
                $font09 = '';
                if (strpos($val, 'Arial, sans-serif') !== false) {
                    $font01 = 'selected="selected"';
                }
                if (strpos($val, 'Verdana, Geneva') !== false) {
                    $font02 = 'selected="selected"';
                }
                if (strpos($val, 'Trebuchet') !== false) {
                    $font03 = 'selected="selected"';
                }
                if (strpos($val, 'Georgia') !== false) {
                    $font04 = 'selected="selected"';
                }
                if (strpos($val, 'Times New Roman') !== false) {
                    $font05 = 'selected="selected"';
                }
                if (strpos($val, 'Tahoma, Geneva') !== false) {
                    $font06 = 'selected="selected"';
                }
                if (strpos($val, 'Palatino') !== false) {
                    $font07 = 'selected="selected"';
                }
                if (strpos($val, 'Helvetica') !== false) {
                    $font08 = 'selected="selected"';
                }

                $output .= '<select class="of-typography of-typography-face" name="' . $value['id'] . '_face" id="' . $value['id'] . '_face">';
                $output .= '<option value="Arial, sans-serif" ' . $font01 . '>Arial</option>';
                $output .= '<option value="Verdana, Geneva, sans-serif" ' . $font02 . '>Verdana</option>';
                $output .= '<option value="&quot;Trebuchet MS&quot;, Tahoma, sans-serif"' . $font03 . '>Trebuchet</option>';
                $output .= '<option value="Georgia, serif" ' . $font04 . '>Georgia</option>';
                $output .= '<option value="&quot;Times New Roman&quot;, serif"' . $font05 . '>Times New Roman</option>';
                $output .= '<option value="Tahoma, Geneva, Verdana, sans-serif"' . $font06 . '>Tahoma</option>';
                $output .= '<option value="Palatino, &quot;Palatino Linotype&quot;, serif"' . $font07 . '>Palatino</option>';
                $output .= '<option value="&quot;Helvetica Neue&quot;, Helvetica, sans-serif" ' . $font08 . '>Helvetica*</option>';
                $output .= '</select>';

                /* Font Weight */
                $val = $default['style'];
                if ($typography_stored['style'] != "") {
                    $val = $typography_stored['style'];
                }
                $normal = '';
                $italic = '';
                $bold = '';
                $bolditalic = '';
                if ($val == 'normal') {
                    $normal = 'selected="selected"';
                }
                if ($val == 'italic') {
                    $italic = 'selected="selected"';
                }
                if ($val == 'bold') {
                    $bold = 'selected="selected"';
                }
                if ($val == 'bold italic') {
                    $bolditalic = 'selected="selected"';
                }

                $output .= '<select class="of-typography of-typography-style" name="' . esc_attr($value['id']) . '_style" id="' . esc_attr($value['id']) . '_style">';
                $output .= '<option value="normal" ' . $normal . '>' . __('Normal', 'rethink') . '</option>';
                $output .= '<option value="italic" ' . $italic . '>' . __('Italic', 'rethink') . '</option>';
                $output .= '<option value="bold" ' . $bold . '>' . __('Bold', 'rethink') . '</option>';
                $output .= '<option value="bold italic" ' . $bolditalic . '>' . __('Bold/Italic', 'rethink') . '</option>';
                $output .= '</select>';

                /* Font Color */
                $val = $default['color'];
                if ($typography_stored['color'] != "") {
                    $val = $typography_stored['color'];
                }
                $output .= '<div id="' . esc_attr($value['id']) . '_color_picker" class="colorSelector"><div></div></div>';
                $output .= '<input class="of-color of-typography of-typography-color" name="' . esc_attr($value['id']) . '_color" id="' . esc_attr($value['id']) . '_color" type="text" value="' . esc_attr($val) . '" />';
                break;

            case "border":

                $default = $value['std'];
                $border_stored = rethink_get_option($value['id']);

                /* Border Width */
                $val = $default['width'];
                if ($border_stored['width'] != "") {
                    $val = $border_stored['width'];
                }
                $output .= '<select class="of-border of-border-width" name="' . esc_attr($value['id']) . '_width" id="' . esc_attr($value['id']) . '_width">';
                for ($i = 0; $i < 21; $i++) {
                    if ($val == $i) {
                        $active = 'selected="selected"';
                    } else {
                        $active = '';
                    }
                    $output .= '<option value="' . $i . '" ' . $active . '>' . $i . 'px</option>';
                }
                $output .= '</select>';

                /* Border Style */
                $val = $default['style'];
                if ($border_stored['style'] != "") {
                    $val = $border_stored['style'];
                }
                $solid = '';
                $dashed = '';
                $dotted = '';
                if ($val == 'solid') {
                    $solid = 'selected="selected"';
                }
                if ($val == 'dashed') {
                    $dashed = 'selected="selected"';
                }
                if ($val == 'dotted') {
                    $dotted = 'selected="selected"';
                }

                $output .= '<select class="of-border of-border-style" name="' . esc_attr($value['id']) . '_style" id="' . esc_attr($value['id']) . '_style">';
                $output .= '<option value="solid" ' . $solid . '>' . __('Solid', 'rethink') . '</option>';
                $output .= '<option value="dashed" ' . $dashed . '>' . __('Dashed', 'rethink') . '</option>';
                $output .= '<option value="dotted" ' . $dotted . '>' . __('Dotted', 'rethink') . '</option>';
                $output .= '</select>';

                /* Border Color */
                $val = $default['color'];
                if ($border_stored['color'] != "") {
                    $val = $border_stored['color'];
                }
                $output .= '<div id="' . esc_attr($value['id']) . '_color_picker" class="colorSelector"><div></div></div>';
                $output .= '<input class="of-color of-border of-border-color" name="' . esc_attr($value['id']) . '_color" id="' . esc_attr($value['id']) . '_color" type="text" value="' . esc_attr($val) . '" />';
                break;

            case "images":
                $i = 0;
                $select_value = rethink_get_option($value['id']);

                foreach ($value['options'] as $key => $option) {
                    $i++;
                    $checked = '';
                    $selected = '';
                    if ($select_value != '') {
                        if ($select_value == $key) {
                            $checked = ' checked';
                            $selected = 'of-radio-img-selected';
                        }
                    } else {
                        if ($value['std'] == $key) {
                            $checked = ' checked';
                            $selected = 'of-radio-img-selected';
                        } elseif ($i == 1 && !isset($select_value)) {
                            $checked = ' checked';
                            $selected = 'of-radio-img-selected';
                        } elseif ($i == 1 && $value['std'] == '') {
                            $checked = ' checked';
                            $selected = 'of-radio-img-selected';
                        } else {
                            $checked = '';
                        }
                    }

                    $output .= '<span>';
                    $output .= '<input type="radio" id="' . esc_attr($value['id'] . '_' . $key) . '" class="of-radio-img-radio" value="' . esc_attr($key) . '" name="' . esc_attr($name) . '" ' . $checked . ' />';
                    $output .= '<div class="of-radio-img-label">' . esc_html($key) . '</div>';
                    $output .= '<img src="' . esc_url($option) . '" alt="' . $option . '" class="of-radio-img-img' . $selected . '" onclick="document.getElementById(\'' . esc_attr($value['id'] . '_' . $key) . '\').checked=true;" />';
                    $output .= '</span>';
                }

                break;

            case "info":
                $default = $value['std'];
                $output .= $default;
                break;

            case "heading":

                if ($counter >= 2) {
                    $output .= '</div>' . "\n";
                }
                $jquery_click_hook = preg_replace("/[^a-zA-Z0-9._\-]/", "", strtolower($value['name']));
                $jquery_click_hook = "of-option-" . esc_attr($jquery_click_hook);
                $menu .= '<li><a title="' . esc_attr($value['name']) . '" href="#' . esc_attr($jquery_click_hook) . '">' . esc_html($value['name']) . '</a></li>';
                $output .= '<div class="group" id="' . esc_attr($jquery_click_hook) . '"><h2>' . esc_html($value['name']) . '</h2>' . "\n";
                break;
            //Start Saperator
            case "saperate":

                break;
            //End Saperator
        }

        // if TYPE is an array, formatted into smaller inputs... ie smaller values
        if (is_array($value['type'])) {
            foreach ($value['type'] as $array) {

                $id = $array['id'];
                $std = $array['std'];
                $saved_std = rethink_get_option($id);
                if ($saved_std != $std) {
                    $std = $saved_std;
                }
                $meta = $array['meta'];

                if ($array['type'] == 'text') { // Only text at this point
                    $output .= '<input class="input-text-small of-input" name="' . esc_attr($id) . '" id="' . esc_attr($id) . '" type="text" value="' . $std . '" />';
                    $output .= '<span class="meta-two">' . $meta . '</span>';
                }
            }
        }
        if ($value['type'] != "heading") {
            if ($value['type'] != "checkbox") {
                $output .= '<br/>';
            }
            if (!isset($value['desc'])) {
                $explain_value = '';
            } else {
                $explain_value = $value['desc'];
            }
            $output .= '</div><div class="explain">' . esc_attr($explain_value) . '</div>' . "\n";
            $output .= '<div class="clear"> </div></div></div>' . "\n";
        }
    }
    $output .= '</div>';
    return array($output, $menu);
}

/* ----------------------------------------------------------------------------------- */
/* OptionsFramework Uploader - rethink_optionsframework_uploader_function */
/* ----------------------------------------------------------------------------------- */

function rethink_optionsframework_uploader_function($id, $std, $mod) {

    //$uploader .= '<input type="file" id="attachement_'.$id.'" name="attachement_'.$id.'" class="upload_input"></input>';
    //$uploader .= '<span class="submit"><input name="save" type="submit" value="Upload" class="button upload_save" /></span>';

    $uploader = '';
    $upload = esc_attr(rethink_get_option($id));

    if ($mod != 'min') {
        $val = $std;
        if (rethink_get_option($id) != "") {
            $val = rethink_get_option($id);
        }
        $uploader .= '<input class="of-input" readonly name="' . esc_attr($id) . '" id="' . esc_attr($id) . '_upload" type="text" value="' . esc_attr($val) . '" />';
    }

    $uploader .= '<div class="upload_button_div"><span class="button image_upload_button" id="' . esc_attr($id) . '">' . __('Upload Image', 'rethink') . '</span>';

    if (!empty($upload)) {
        $hide = '';
    } else {
        $hide = 'hide';
    }

    $uploader .= '<span class="button image_reset_button ' . $hide . '" id="reset_' . esc_attr($id) . '" title="' . esc_attr($id) . '">' . __('Remove', 'rethink') . '</span>';
    $uploader .='</div>' . "\n";
    $uploader .= '<div class="clear"></div>' . "\n";
    $findme = 'wp-content/uploads';
    $imgvideocheck = strpos($upload, $findme);
    if ((!empty($upload)) && ($imgvideocheck === true)) {
        $uploader .= '<a class="of-uploaded-image" href="' . $upload . '">';
        $uploader .= '<img class="of-option-image" id="image_' . esc_attr($id) . '" src="' . $upload . '" alt="" />';
        $uploader .= '</a>';
    }
    $uploader .= '<div class="clear"></div>' . "\n";
    return $uploader;
}
?>