<?php
/**
 * The main template file.
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query. 
 * E.g., it puts together the home page when no home.php file exists.
 * Learn more: http://codex.wordpress.org/Template_Hierarchy
 *
 */
get_header();
?>
<div class="full-content">
    <div class="grid_17 alpha">
        <div class="content_bar">
            <section class="slider">
                <div class="flexslider">
                    <ul class="slides">
                        <li>
                            <?php if (get_header_image()) { ?>
                                <a href="<?php echo esc_url(home_url('/')); ?>">			
                                    <img src="<?php header_image(); ?>" class="header-image" width="<?php echo get_custom_header()->width; ?>" height="<?php echo get_custom_header()->height; ?>" alt="" />
                                </a>
                            <?php } else { ?>
                                <a href="<?php echo esc_url(home_url('/')); ?>">
                                    <img src="<?php echo get_template_directory_uri(); ?>/images/slide-1.jpg"/>
                                </a>
                            <?php } ?> 
                        </li> 
                    </ul>
                </div>
            </section>
            <div class="feature_content">
                <!--Start Post-->
                <?php get_template_part('loop', 'index'); ?>
                <!--End Post-->
                <div class="clear"></div>
                <?php
                echo '<div class="paging">';
                echo paginate_links(array('prev_text' => '&lsaquo;',
                    'next_text' => '&rsaquo;',
                ));
                echo "</div>";
                ?>
            </div>              
        </div>
    </div>
    <div class="grid_7 omega">
        <!--Start Sidebar-->
        <?php get_sidebar(); ?>
        <!--End Sidebar-->
    </div>       
</div>
<?php get_footer(); ?>